#
# Conditional build:
%bcond_without	apidocs		# do not build and package API docs
%bcond_with	mpi		# MPI support

Summary:	Lunchbox - C++ library for multi-threading programming
Summary(pl.UTF-8):	Lunchbox - biblioteka C++ do programowania wielowątkowego
Name:		Lunchbox
Version:	1.17.0
Release:	8
License:	LGPL v2.1
Group:		Libraries
#Source0Download: https://github.com/Eyescale/Lunchbox/releases
Source0:	https://github.com/Eyescale/Lunchbox/archive/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	76bcd79003c9b9d58d5f772cfdd812c7
Patch0:		cxx.patch
Patch1:		nanosleep.patch
URL:		http://pogl.wordpress.com/category/lunchbox/
BuildRequires:	Eyescale-CMake >= 2018.02
BuildRequires:	Servus-devel >= 1.5.0
BuildRequires:	avahi-devel
BuildRequires:	boost-devel >= 1.41.0
BuildRequires:	cmake >= 3.1
%{?with_apidocs:BuildRequires:	doxygen}
BuildRequires:	hwloc-devel >= 1.3
BuildRequires:	hwloc-devel < 2
BuildRequires:	libstdc++-devel
%{?with_mpi:BuildRequires:	mpi-devel}
BuildRequires:	pkgconfig
BuildRequires:	rpm-build >= 4.6
BuildRequires:	rpmbuild(macros) >= 1.605
Requires:	Servus >= 1.5.0
Requires:	hwloc-libs >= 1.3
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Lunchbox is a C++ library for multi-threaded programming. Lunchbox was
formerly known as eq::base or co::base, the foundation for the
Equalizer parallel rendering framework and the Collage network
library. It is intended for all application developers creating
high-performance multi-threaded programs.

%description -l pl.UTF-8
Lunchbox to biblioteka C++ do programowania wielowątkowego. Wcześniej
była znana jako eq::base lub co::base - podstawa szkieletu do
renderowania wielowątkowego Equalizer lub biblioteki sieciowej
Collage. Biblioteka jest przeznaczona dla wszystkich programistów
tworzących wysoko wydajne, wielowątkowe aplikacje.

%package devel
Summary:	Header files for Lunchbox library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki Lunchbox
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	Servus-devel >= 1.5.0
Requires:	boost-devel >= 1.41.0
Requires:	libstdc++-devel

%description devel
Header files for Lunchbox library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki Lunchbox.

%package apidocs
Summary:	Lunchbox API documentation
Summary(pl.UTF-8):	Dokumentacja API biblioteki Lunchbox
Group:		Documentation
BuildArch:	noarch

%description apidocs
API documentation for Lunchbox library.

%description apidocs -l pl.UTF-8
Dokumentacja API biblioteki Lunchbox.

%prep
%setup -q

rmdir CMake/common
ln -s %{_datadir}/Eyescale-CMake CMake/common

%patch0 -p1
%patch1 -p1

%build
install -d build
cd build
%cmake .. \
	-DCOMMON_DISABLE_WERROR:BOOL=ON \
	%{!?with_mpi:-DCMAKE_DISABLE_FIND_PACKAGE_MPI=ON}

%{__make}

%if %{with apidocs}
doxygen doc/Doxyfile
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

%{__rm} -r $RPM_BUILD_ROOT%{_datadir}/Lunchbox/{doc,tests}

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc ACKNOWLEDGEMENTS.txt AUTHORS.txt CHANGES.txt LICENSE.txt README.md doc/Changelog.md
%attr(755,root,root) %{_libdir}/libLunchbox.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libLunchbox.so.10
%dir %{_datadir}/Lunchbox
%{_datadir}/Lunchbox/benchmarks

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libLunchbox.so
%{_includedir}/lunchbox
%{_datadir}/Lunchbox/CMake

%if %{with apidocs}
%files apidocs
%defattr(644,root,root,755)
%doc build/doc/html/*
%endif
%changelog
* Fri Jun 30 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/Lunchbox.git;a=log;h=master

* Fri Jun 30 2023 Jan Palus <atler@pld-linux.org> 737d614
- boost rebuild

* Sat Feb 18 2023 Jan Palus <atler@pld-linux.org> 0ebcb18
- boost rebuild

* Sat Feb 18 2023 Jan Palus <atler@pld-linux.org> 7aff8a4
- correct nanosleep patch

* Sat Feb 18 2023 Jan Palus <atler@pld-linux.org> 38861d5
- rpm version for noarch subpackage

* Sat Feb 18 2023 Jan Palus <atler@pld-linux.org> b1c9786
- macros for %cmake

* Sat Feb 18 2023 Jan Palus <atler@pld-linux.org> bb2938e
- upstream fix for missing include for nanosleep

* Mon Jun 06 2022 Jan Palus <atler@pld-linux.org> 2e8f5ec
- boost rebuild

* Sun Jan 16 2022 Jan Palus <atler@pld-linux.org> c3295d4
- boost rebuild

* Tue Aug 10 2021 Jan Palus <atler@pld-linux.org> b0ed2b3
- boost rebuild

* Sun Feb 28 2021 Jan Rękorajski <baggins@pld-linux.org> e57480b
- unconditional noarch subpackages

* Fri Jul 31 2020 Jakub Bogusz <qboosh@pld-linux.org> 1b7bae6
- release 3 (boost 1.73)

* Wed Oct 09 2019 Jan Rękorajski <baggins@pld-linux.org> a898ce3
- rebuild with boost 1.71
- release 2 (by relup.sh)

* Sun May 26 2019 Jakub Bogusz <qboosh@pld-linux.org> 7c79b47
- updated to 1.17.0 (note: new soname)
- updated cxx patch

* Sat Apr 20 2019 Jan Rękorajski <baggins@pld-linux.org> 87a51c8
- disable -Werror to be able to build with modern gcc
- rel 2

* Fri Apr 14 2017 Jan Rękorajski <baggins@pld-linux.org> 99b9090
- up to 1.15.0

* Sat May 28 2016 Jan Rękorajski <baggins@pld-linux.org> c6de7ca
- up to 1.13.0

* Tue May 24 2016 Jan Rękorajski <baggins@pld-linux.org> 382ae9e
- fix building with modern g++
- rel 7

* Sun Jan 10 2016 Elan Ruusamäe <glen@delfi.ee> 3da0d94
- noarch apidoc

* Sun Nov 15 2015 Jan Rękorajski <baggins@pld-linux.org> 5a31b40
- release 5 (by relup.sh)

* Wed Jun 10 2015 Jan Rękorajski <baggins@pld-linux.org> 136f2c6
- release 4 (by relup.sh)

